/*
 * Copyright (c) 2002, Adam Dunkels.
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution. 
 * 3. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior
 *    written permission.  
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
 *
 * This file is part of the "ctk" console GUI toolkit for cc65
 *
 * $Id: ctk-conio.h,v 1.1 2006/06/17 22:41:15 adamdunkels Exp $
 *
 */

#ifndef __CTK_CONIO_H__
#define __CTK_CONIO_H__

#include <conio.h>

typedef char ctk_arch_key_t;

#define ctk_arch_keyavail kbhit
#define ctk_arch_getkey   cgetc

#ifndef CH_ENTER
#define CH_ENTER '\n'
#endif /* CH_ENTER */

#ifndef CH_F1
#define CH_F1 CH_ESC
#endif /* CH_F1 */

#ifndef CH_F3
#define CH_F3 CH_STOP
#endif /* CH_F1 */

#ifndef CH_CURS_RIGHT
#define CH_CURS_RIGHT 254
#endif /* CH_CURS_RIGHT */

#ifndef CH_CURS_LEFT
#define CH_CURS_LEFT 255
#endif /* CH_CURS_LEFT */

#endif /* __CTK_CONIO_H__ */
