/*
 * Copyright (c) 2010, Mariano Alvira <mar@devl.org> and other contributors
 * to the MC1322x project (http://mc1322x.devl.org) and Contiki.
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Institute nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * This file is part of the Contiki OS.
 *
 * $Id: uart1.h,v 1.1 2010/06/10 14:55:39 maralvira Exp $
 */

/*

  This file exists as a work-around for the hardware dependant calls
  to slip_arch_init.

  Current the prototype for slip_arch_init is slip_arch_init(urb)

  and a typical call is something like
  slip_arch_init(BAUD2URB(115200))

  BAUD2UBR is hardware specific, however. Furthermore, for the sky
  platform it's typically defined with #include "dev/uart1.h" (see
  rpl-boarder-router/slip-bridge.c), a sky specific file. dev/uart1.h
  includes msp430.h which includes the sky contiki-conf.h which
  defines BAUD2UBR.

  To me, the correct think to pass is simply the baudrate and have the
  hardware specific conversion happen inside slip_arch_init. 

  Notably, most implementations just ignore the passed parameter
  anyway. (except AVR)
  
 */

#ifndef DEV_UART1_H
#define DEV_UART1_H

#define BAUD2UBR(x) x

#endif
